<template>
  <div class="d-flex flex-column flex-grow-1">
    <div class="d-flex align-center py-3">
      <div>
        <div class="display-1">{{ $t("menu.ManagePhotos") }}</div>
        <v-breadcrumbs :items="breadcrumbs" class="pa-0 py-2"></v-breadcrumbs>
      </div>
      <v-spacer></v-spacer>
    </div>
    <v-container fluid class="filter">
      <v-row align="center">
        <v-col cols="7" md="8">
          <v-text-field
            rounded
            outlined
            :label="$t('common.SearchInAll')"
            v-model.trim="search"
            hide-details
            clearable
            prepend-inner-icon="mdi-magnify"
          ></v-text-field>
        </v-col>
        <v-col cols="2" md="2">
          <v-btn
            rounded
            block
            height="55"
            class="mygrad"
            dark
            @click="
              searchPage();

            "
          >
            {{ $t("common.Search") }}
          </v-btn>
        </v-col>
        <v-col cols="2" md="2">
          <v-btn
            rounded
            block
            height="55"
            class="mygrad"
            dark
            @click="
              search = '';
              fetchRecords({ search });
            "
          >
            {{ $t("common.showAll") }}
          </v-btn>
        </v-col>
      </v-row>
    </v-container>
    <v-card>
      <v-data-table
        :headers="headers"
        :items="getProviderImagesList"
        loading-text="جاري تحميل البيانات"
        no-data-text="لا يوجد بيانات"
        hide-default-footer
        disable-filtering
        disable-pagination
        disable-sort
        class="elevation-1"
      >
        <template v-slot:item.id="{ item }">
          <div class="font-weight-bold">
            # <copy-label :text="item.id + ''" />
          </div>
        </template>
        <template v-slot:item.createdAt="{ item }">
          <div>{{ item.createdAt | formatDate("ll") }}</div>
        </template>
        <template v-slot:item.url="{ item }">
          <v-dialog transition="dialog-top-transition" max-width="600">
            <template v-slot:activator="{ on, attrs }">
              <img
                height="80"
                class="my-2"
                :src="item.url"
                v-bind="attrs"
                v-on="on"
              />
            </template>
            <template v-slot:default="dialog">
              <v-card>
                <v-toolbar class="mygrad" dark>{{
                  $t("common.showPhoto")
                }}</v-toolbar>
                <v-card-text>
                  <v-img :src="item.url"> </v-img>
                </v-card-text>
                <v-card-actions class="justify-end">
                  <v-btn text @click="dialog.value = false">{{
                    $t("common.cancel")
                  }}</v-btn>
                </v-card-actions>
              </v-card>
            </template>
          </v-dialog>
        </template>
        <template v-slot:item.action="{ item }">
          <div class="actions">
            <!-- approve or disapprove image -->
            <!-- publishImage -->

            <v-dialog transition="dialog-top-transition" max-width="600">
              <template v-slot:activator="{ on, attrs }">
                <v-btn
                  fab
                  small
                  dark
                  class="mx-3 mygrad"
                  v-bind="attrs"
                  v-on="on"
                >
                  <v-icon class="mt-1 my-1">mdi-check-all</v-icon>
                </v-btn>
              </template>
              <template v-slot:default="dialog">
                <v-card>
                  <v-toolbar class="mygrad" dark>{{
                    $t("common.ApproveImage")
                  }}</v-toolbar>
                  <v-card-text class="py-2">
                    <v-img :src="item.url"> </v-img>
                  </v-card-text>
                  <v-card-actions class="justify-end">
                    <v-btn
                      class="mygrad"
                      dark
                      @click="
                        publishImage(item);
                        dialog.value = false;
                      "
                    >
                      {{ $t("common.Approve") }}
                    </v-btn>
                    <v-btn text @click="dialog.value = false">{{
                      $t("common.cancel")
                    }}</v-btn>
                  </v-card-actions>
                </v-card>
              </template>
            </v-dialog>
            <!-- RejectPublishImage -->
            <v-dialog transition="dialog-top-transition" max-width="600">
              <template v-slot:activator="{ on, attrs }">
                <v-btn
                  v-bind="attrs"
                  v-on="on"
                  color="#E07979"
                  fab
                  small
                  dark
                  class="mx-3"
                >
                  <v-icon class="mt-1 my-1"
                    >mdi mdi-close-outline</v-icon
                  ></v-btn
                >
              </template>
              <template v-slot:default="dialog">
                <v-card>
                  <v-toolbar class="mygrad" dark>{{
                    $t("common.RejectImage")
                  }}</v-toolbar>
                  <v-card-text class="py-2">
                    <v-textarea
                      v-model="RejectReason"
                      rows="4"
                      prepend-icon="mdi-pen"
                      outlined
                      :label="$t('common.RejectReason')"
                    ></v-textarea>
                  </v-card-text>
                  <v-card-actions class="justify-end">
                    <v-btn
                      color="#E07979"
                      dark
                      @click="
                        RejectPublishImage(item);
                        dialog.value = false;
                        RejectReason = '';
                      "
                    >
                      {{ $t("common.Reject") }}
                    </v-btn>
                    <v-btn
                      text
                      @click="
                        dialog.value = false;
                        RejectReason = '';
                      "
                      >{{ $t("common.cancel") }}</v-btn
                    >
                  </v-card-actions>
                </v-card>
              </template>
            </v-dialog>
          </div>
        </template>
      </v-data-table>

      <v-snackbar v-model="snack" :timeout="3000" :color="snackColor">
        {{ snackText }}

        <template v-slot:action="{ attrs }">
          <v-btn v-bind="attrs" text @click="snack = false">Close</v-btn>
        </template>
      </v-snackbar>
    </v-card>
    <!-- PAGINATION -->
    <div class="text-center">
      <v-container>
        <v-row justify="center">
          <v-col cols="8">
            <v-container class="max-width">
              <v-pagination
                v-model="page"
                circle
                total-visible="7"
                class="my-4"
                :length="getLastPage"
                @input="handlingRoute($event)"
              ></v-pagination>
            </v-container>
          </v-col>
        </v-row>
      </v-container>
    </div>
  </div>
</template>

<script>
import CopyLabel from "../../components/common/CopyLabel";
import { mapActions, mapGetters, mapMutations } from "vuex";
export default {
  components: {
    CopyLabel,
  },
  data() {
    return {
      RejectReason: "",
      snack: false,
      snackColor: "",
      snackText: "",
      date: "",
      search: "",
      menu: false,
      isLoading: false,
      page: this.getFilter,
      breadcrumbs: [
        {
          text: this.$i18n.t("menu.ManagePhotos"),
          disabled: false,
          href: "#",
        },
        {
          text: this.$i18n.t("menu.List"),
        },
      ],

      headers: [
        { text: this.$i18n.t("provider.Name"), value: "provider.name" },
        { text: this.$i18n.t("provider.createdAt"), value: "createdAt" },

        { text: this.$i18n.t("provider.image"), value: "url" },
        {
          text: this.$i18n.t("provider.approve"),
          sortable: false,

          value: "action",
        },
      ],
    };
  },
  methods: {
    async publishImage(item) {
      this.isLoading = true;
      this.approveOrDisapproveImage({
        id: item.id,
        isActive: true,
      }).then((res) => {
        this.snack = true;
        this.snackColor = "success";
        this.snackText = res.data.message;
        this.isLoading = false;
        this.fetchRecords({ search: this.search });
      });
    },
    RejectPublishImage(item) {
      this.isLoading = true;
      this.approveOrDisapproveImage({
        id: item.id,
        isActive: false,
        RejectReason: this.RejectReason,
      }).then(() => {
        this.snack = true;
        this.snackColor = "success";
        this.snackText = "Image has been Unapproved";
        this.isLoading = false;
        this.fetchRecords({ search: this.search });
      });
    },
    searchPage() {
      this.$router.push(`?PageNumber=1`).then(()=>{
        this.fetchRecords({ search: this.search });
      }
      )

    },
    ...mapMutations("providerImages", ["setFilter"]),
    handlingRoute(event) {
      if (this.$route.path != `?PageNumber=${event}`) {
        this.$router.push(`?PageNumber=${event}`);
      }
    },
    ...mapActions("providerImages", [
      "fetchRecords",
      "approveOrDisapproveImage",
    ]),
  },
  watch: {
    $route: {
      async handler(route) {
        if (!route.query.PageNumber) {
          await this.$router.replace({
            query: { ...route.query, PageNumber: 1 },
          });
          return;
        }
        this.setFilter({ ...route.query });
        this.$store
          .dispatch("providerImages/fetchRecords", route.query)
          .then(() => {
            this.loading = false;
          });
      },
      deep: true,
      immediate: true,
    },
  },

  computed: {
    ...mapGetters("providerImages", [
      "getProviderImagesList",
      "getLastPage",
      "getFilter",
    ]),
  },
};
</script>

<style lang="scss">
.filter {
  background-color: #fff;
}
.slide-fade-enter-active {
  transition: all 0.3s ease;
}
.slide-fade-leave-active {
  transition: all 0.3s cubic-bezier(1, 0.5, 0.8, 1);
}
.slide-fade-enter,
.slide-fade-leave-to {
  transform: translateX(10px);
  opacity: 0;
}
.img-thumbnail:hover {
  cursor: pointer;
  width: 180px;
  transition: 0.5s ease all;
}
</style>
